﻿/*
 * Created by SharpDevelop.
 * User: pdf
 * Date: 5/2/2017
 * Time: 10:43 AM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;
using EasyModbus;


namespace TCPModbusRemote
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		ModbusServer modbusserver;
		
		public MainForm()
		{
			InitializeComponent();

			modbusserver = new ModbusServer();
			modbusserver.holdingRegistersChanged += new ModbusServer.HoldingRegistersChanged(this.registersChanged);
			modbusserver.Listen();  // port 502 (default)
		}
		
		void MainFormFormClosing(object sender, FormClosingEventArgs e)
		{
			modbusserver.StopListening();
		}
		
		void registersChanged(int registernum, int numchanged)
		{
			
			// the UCCNC macro must 
			// SetModbusregisters(Startregister, ushort[] Values)
			// where Startregister=0 and the Values array
			// contains 10 values (DRO_COUNT * 2)

			float fXDRO =  int16sToFloat(modbusserver.holdingRegisters[1],  modbusserver.holdingRegisters[2]);
			float fYDRO =  int16sToFloat(modbusserver.holdingRegisters[3],  modbusserver.holdingRegisters[4]);
			float fZDRO =  int16sToFloat(modbusserver.holdingRegisters[5],  modbusserver.holdingRegisters[6]);
			float fFEED =  int16sToFloat(modbusserver.holdingRegisters[7],  modbusserver.holdingRegisters[8]);
			float fSPEED= int16sToFloat(modbusserver.holdingRegisters[9],  modbusserver.holdingRegisters[10]);

			// modbusserver runs in a thread
			// we need to join the GUI thread to update controls
			MethodInvoker inv = delegate
    		{

				XDRO.Text = String.Format("{0:###.000}", fXDRO);
				YDRO.Text = String.Format("{0:###.000}", fYDRO); 
				ZDRO.Text = String.Format("{0:##0.000}", fZDRO); 
				FEED.Text = String.Format("{0:###.000}", fFEED); 
				SPEED.Text =String.Format("{0:000.000}", fSPEED); 
    		};
 			Invoke(inv);
 			
		}
		
		float int16sToFloat(short s1, short s2)
		{
		    /* Here we convert the 2 uint16's from consecutive registers
		     * back into a float to display
		    */
		    byte[] s1Bytes = BitConverter.GetBytes(s1);
		    byte[] s2Bytes = BitConverter.GetBytes(s2);
		    
		    // concatenate the byte arrays
			byte[] combined = s2Bytes.Concat(s1Bytes).ToArray();
			
			// convert array to a float
			return BitConverter.ToSingle(combined, 0);
		}

	}
}
